Summary:       An eBPF-based tool to trace network packet and diagnose network problem
Name:          nettrace
Version:       1.2.9
Release:       1%{?dist}
License:       MulanPSL-2.0
URL:           https://github.com/OpenCloudOS/nettrace
Source0:       %{URL}/archive/refs/tags/v%{version}.tar.gz #/%{name}-%{version}.tar.gz
Patch5000:     remove-static-compile-flag.patch

BuildRequires: elfutils-devel libbpf-devel python3 python3-pyyaml
BuildRequires: kernel-headers kernel-devel clang llvm gcc bpftool
BuildRequires: glibc-devel  zlib-devel python3 python3-pyyaml
Requires:      elfutils-libelf libbpf zlib libzstd

%description
nettrace is is a powerful tool to trace network packet and diagnose
network problem inside kernel. It make use of eBPF.

'skb' is the struct that used in kernel to store network package.
By tracing kernel function and tracepoint (with the help of kprobe
based on eBPF) that handle skb, nettrace is able to show the path
of skb bypass inside kernel network stack. Therefor, some network
issue (such as package drop) can be solved simply.


%prep
%autosetup -p1


%install
rm -rf %{buildroot}
make PREFIX=%{buildroot} install
PREFIX=%{buildroot}


%files
%defattr (-,root,root,0755)
%{_bindir}/nettrace
%{_datadir}/man/zh_CN/man8/nettrace.8.gz
%{_datadir}/man/man8/nettrace.8.gz
%{_datadir}/man/man8/dropreason.8.gz
%{_datadir}/bash-completion/completions/nettrace


%changelog
* Thu Apr 18 2024 rockerzhu <rockerzhu@tencent.com> - 1.2.9-1
- Upgrade to 1.2.9
- Improve the SPEC file to adapt the new os release.

* Tue Jan 10 2023 Xun Zhong <victorzhong@tencent.com> - 1.2.3-1
- init
